function [tt xx]=rk42(fun,params,ti,tf,xi,h)

n=floor( (tf-ti)/h );
dim=length(xi);

xx=zeros(n+1,dim);
tt=zeros(n+1,1);

xn=xi';
tt(1)=ti;
xx(1,:)=xi;
tt(1)=0;
for it=1:n
    t=ti+it*h; tt(it+1)=t;
    k1=fun(t,xn,params);
    k2=fun(t+h/2,xn+h/2*k1,params);
    k3=fun(t+h/2,xn+h/2*k2,params);
    k4=fun(t+h,xn+k3*h,params);

    xn=xn+h/6*(k1+2*k2+2*k3+k4);    
    xx(it+1,1)=xn(1);
    xx(it+1,2)=xn(2);
end

